# `pure(UnpureComponent): PureComponent`

Makre provided component pure - it means that component not rerender until they props change. 

### Arguments
1. `UnpureComponent`: React component that should be optimilized for useless rerenderes.

### Returns
Component that rerender only if their props change. Change is determined by deep equality, using
lodash `isEqual` function.


### Examples

```jsx
import pure from 'ackee-frontend-toolkit/lib/HOC/pure';

pure(({ data }) => (
    <div>
        { JSON.stringify(data, null, 2) }
    </div>
));
```
